*=== lattic ===========================================================*
*
      SUBROUTINE LATTIC ( XB, WB, DIST, SB, UB, IR, IRLTGG, IRLT, IFLAG)
* === For FLUKA === *
      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
      INCLUDE '(GLTLOC)'
      INCLUDE '(RTGMMV)'
*
      LOGICAL LFIRST
      DIMENSION IRLT (*)
      DIMENSION XB   (3), WB (3), SB (3), UB (3), UN (3)
      SAVE IRLSAV, LFIRST
*
      DATA LFIRST /.TRUE./
      DATA IRLSAV / -1 /
*
      INTEGER IND(15000)
      DOUBLE PRECISION DELX(15000)
      DOUBLE PRECISION DELY(15000)
      INTEGER I
      DOUBLE PRECISION BUFDELX
      DOUBLE PRECISION BUFDELY
      INTEGER BUFI
*
      SAVE IND, DELX, DELY
*  +-------------------------------------------------------------------*
*  |  First time initialization:
      IF ( LFIRST ) THEN
         LFIRST = .FALSE.
         WRITE(*,*) 'LATTIC FIRST CALL'
         DO I = 1, 15000
            IND(I) = I
            DELX(I) = 0.
            DELY(I) = 0.
         END DO
         WRITE(*,*) 'INITIALIZATION OF DELTA X,Y ARRAYS DONE'
*
         OPEN(2, ACTION = 'READ', FILE = '../Cells.dat')
         DO 
            READ(2, FMT = *) BUFI, BUFDELX, BUFDELY
            IF (BUFI .EQ. -1) THEN
               EXIT
            ENDIF
            DELX(BUFI) = BUFDELX
            DELY(BUFI) = BUFDELY
*            WRITE(*,*) BUFI, BUFDELX, BUFDELY
         END DO
         CLOSE(2)
      END IF
*  |
*  +-------------------------------------------------------------------*
*  +-------------------------------------------------------------------*
*  |
      IF ( IRLTGG .NE. IRLSAV ) THEN
*  |  Get the region index corresponding to Irltgg
         IRCELL = IRLT ( IRLTGG - KLTCL0 + 1 )
         SB (1) = XB (1) + DELX(IRCELL)
         SB (2) = XB (2) + DELY(IRCELL)
         SB (3) = XB (3)
         UB (1) = WB (1)
         UB (2) = WB (2)
         UB (3) = WB (3)
      END IF
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Entry LATNOR:                                                    *
*                                                                      *
*======================================================================*
*
      ENTRY LATNOR ( UN, IRLTNO, IRLT )
*
*----------------------------------------------------------------------*
*                                                                      *
*     LATtice cell NORmal transformation:                              *
*                                                                      *
*     Input variables:                                                 *
*                      un(i) = normal components in the tracking re-   *
*                              ference system                          *
*                     irltno = present lattice cell #                  *
*     Output variables:                                                *
*                      un(i) = normal components in the problem re-    *
*                              ference system                          *
*                                                                      *
*----------------------------------------------------------------------*
*
*  Get the region index corresponding to Irltno
      IRCELL = IRLT ( IRLTNO - KLTCL0 + 1 )
*  Get a possible rotation index for this region/lattice:
      KROTAT = ILTRTN ( IRCELL )
*  +-------------------------------------------------------------------*
*  |  A rotation is defined for this lattice:
      IF ( KROTAT .GT. 0 ) THEN
         CALL UNDRTO ( 1, UN (1), UN (2), UN (3), KROTAT )
         RETURN
*  |
*  +-------------------------------------------------------------------*
*  |  A (negative) rotation is defined for this lattice:
      ELSE IF ( KROTAT .LT. 0 ) THEN
         CALL DORTNO ( 1, UN (1), UN (2), UN (3), -KROTAT )
         RETURN
      END IF
*  |
*  +-------------------------------------------------------------------*
      GO TO ( 5050, 5100, 5200, 5300), IRLTNO + 1
         WRITE(LUNOUT,*)' *** Lattice geometry non supported !!! ***',
     &                    IRLTNO
         STOP
 5050 CONTINUE
      GO TO 8888
 5100 CONTINUE
         UN (1) = UN (1)
         UN (2) = UN (2)
         UN (3) =-UN (3)
      GO TO 8888
 5200 CONTINUE
         UN (1) = UN (1)
         UN (2) = UN (2)
         UN (3) = UN (3)
      GO TO 8888
 5300 CONTINUE
         UN (1) = UN (1)
         UN (2) = UN (2)
         UN (3) =-UN (3)
      GO TO 8888
* *********** 4,5,6 Not yet used by any run ********* *
 8888 CONTINUE
      RETURN
*=== End of subroutine lattic =========================================*
      END

